/*
 * Copyright 1999-2019 Alibaba Group Holding Ltd.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package com.alibaba.chaosblade.exec.common.aop;

import java.lang.reflect.Method;

/**
 * @author Changjun Xiao
 */
public interface Enhancer {

    /**
     * 方法执行前，增强处理
     *
     * @param targetName
     * @param classLoader     类加载器
     * @param className
     * @param object          处理的对象
     * @param method          对象的方法
     * @param methodArguments 对象的方法参数
     * @return 自定义结果
     * @throws Exception
     */
    void beforeAdvice(String targetName, ClassLoader classLoader, String className, Object object,
                      Method method,
                      Object[] methodArguments)
        throws Exception;
}
